#include "oledfont.h"
#include "delay.h"
#include "oled.h"

//******************************************************************************
//    ˵OLEDдһָ
//    ݣdat 
//    ֵ  
//******************************************************************************
void OLED_WR_Bus(u8 dat)
{
	u8 i;
	OLED_CS_Clr();
	for(i=0;i<8;i++)
	{			  
		OLED_SCL_Clr();
		if(dat&0x80)
		{
		   OLED_SDA_Set();
		}
		else 
		{
		   OLED_SDA_Clr();
		}
		OLED_SCL_Set();
		dat<<=1;   
	}				 		  
	OLED_CS_Set();
}

//******************************************************************************
//    ˵OLEDдһָ
//    ݣreg ָ
//    ֵ  
//******************************************************************************
void OLED_WR_REG(u8 reg)
{	  
	OLED_DC_Clr();		  
  OLED_WR_Bus(reg);
  OLED_DC_Set();	
}

//******************************************************************************
//    ˵OLEDдһ
//    ݣdat 
//    ֵ  
//******************************************************************************
void OLED_WR_Byte(u8 dat)
{	  
  OLED_WR_Bus(dat);
}

//******************************************************************************
//    ˵OLEDʾеʼַֹ
//    ݣa  еʼַ
//              b  еַֹ
//    ֵ  
//******************************************************************************
void Column_Address(u8 a,u8 b)
{
	OLED_WR_REG(0x15);       // Set Column Address
	OLED_WR_Byte(0x1c+a);
	OLED_WR_Byte(0x1c+b);
}


//******************************************************************************
//    ˵OLEDʾеʼַֹ
//    ݣa  еʼַ
//              b  еַֹ
//    ֵ  
//******************************************************************************
void Row_Address(u8 a,u8 b)
{
	OLED_WR_REG(0x75);       // Row Column Address
	OLED_WR_Byte(a);
	OLED_WR_Byte(b);
	OLED_WR_REG(0x5C);    //дRAM
}


//******************************************************************************
//    ˵OLED亯
//    ݣxstr,ystr:亯ʼ
//              xend,yend:亯
//              color:ɫֵ
//    ֵ  
//******************************************************************************
void OLED_Fill(u16 xstr,u8 ystr,u16 xend,u8 yend,u8 color)
{
	u8 x,y;
	xstr/=4;
	xend/=4;
	Column_Address(xstr,xend-1);
	Row_Address(ystr,yend-1);
	for(x=xstr;x<xend;x++)
	{
		for(y=ystr;y<yend;y++)
		{
			OLED_WR_Byte(color);
			OLED_WR_Byte(color);
    }
  }
}

//******************************************************************************
//    ˵OLEDʾ
//    ݣx,y :
//              *s  :Ҫʾĺִ
//              sizey ַ߶ 
//              mode  0:ʾ1ɫʾ
//    ֵ  
//******************************************************************************
void OLED_ShowChinese(u8 x,u8 y,u8 *s,u8 sizey,u8 mode)
{
	while(*s!=0)
	{
		if(sizey==16) OLED_ShowChinese16x16(x,y,s,sizey,mode);
		else if(sizey==24) OLED_ShowChinese24x24(x,y,s,sizey,mode);
		else if(sizey==32) OLED_ShowChinese32x32(x,y,s,sizey,mode);
		else return;
		s+=2;
		x+=sizey;
	}
}
//******************************************************************************
//    ˵OLEDʾ
//    ݣx,y :
//              *s  :Ҫʾĺ
//              sizey ַ߶ 
//              mode  0:ʾ1ɫʾ
//    ֵ  
//******************************************************************************
void OLED_ShowChinese16x16(u8 x,u8 y,u8 *s,u8 sizey,u8 mode)
{
	u8 i,j,k,DATA=0;
	u16 HZnum;//Ŀ
	u16 TypefaceNum;//һַռֽڴС
	TypefaceNum=(sizey/8+((sizey%8)?1:0))*sizey;//ַռֽ
	HZnum=sizeof(tfont16)/sizeof(typFNT_GB16);	//ͳƺֿĿ
	Column_Address(x/4,x/4+sizey/4-1);
	Row_Address(y,y+sizey-1);
	for(k=0;k<HZnum;k++)
	{
		if ((tfont16[k].Index[0]==*(s))&&(tfont16[k].Index[1]==*(s+1)))
		{ 	
			for(i=0;i<TypefaceNum;i++)
			{
				for(j=0;j<4;j++)
				{
					if(tfont16[k].Msk[i]&(0x01<<(j*2+0)))
					{
						DATA=0xf0;
					}
					if(tfont16[k].Msk[i]&(0x01<<(j*2+1)))
					{
						DATA|=0x0f;
					}
					if(mode)
					{
						OLED_WR_Byte(~DATA);
					}else
					{
						OLED_WR_Byte(DATA);
					}
					DATA=0;
				}
			}
		}				  	
		continue;  //ҵӦֿ˳ֹظȡģӰ
	}
} 

//******************************************************************************
//    ˵OLEDʾ
//    ݣx,y :
//              *s  :Ҫʾĺ
//              sizey ַ߶ 
//              mode  0:ʾ1ɫʾ
//    ֵ  
//******************************************************************************
void OLED_ShowChinese24x24(u8 x,u8 y,u8 *s,u8 sizey,u8 mode)
{
	u8 i,j,k,DATA=0;
	u16 HZnum;//Ŀ
	u16 TypefaceNum;//һַռֽڴС
	TypefaceNum=(sizey/8+((sizey%8)?1:0))*sizey;//ַռֽ
	HZnum=sizeof(tfont24)/sizeof(typFNT_GB24);	//ͳƺֿĿ
	Column_Address(x/4,x/4+sizey/4-1);
	Row_Address(y,y+sizey-1);
	for(k=0;k<HZnum;k++)
	{
		if ((tfont24[k].Index[0]==*(s))&&(tfont24[k].Index[1]==*(s+1)))
		{ 	
			for(i=0;i<TypefaceNum;i++)
			{
				for(j=0;j<4;j++)
				{
					if(tfont24[k].Msk[i]&(0x01<<(j*2+0)))
					{
						DATA=0xf0;
					}
					if(tfont24[k].Msk[i]&(0x01<<(j*2+1)))
					{
						DATA|=0x0f;
					}
					if(mode)
					{
						OLED_WR_Byte(~DATA);
					}else
					{
						OLED_WR_Byte(DATA);
					}
					DATA=0;
				}
			}
		}				  	
		continue;  //ҵӦֿ˳ֹظȡģӰ
	}
} 

//******************************************************************************
//    ˵OLEDʾ32x32
//    ݣx,y :
//              *s  :Ҫʾĺ
//              sizey ַ߶ 
//              mode  0:ʾ1ɫʾ
//    ֵ  
//******************************************************************************
void OLED_ShowChinese32x32(u8 x,u8 y,u8 *s,u8 sizey,u8 mode)
{
	u8 i,j,k,DATA=0;
	u16 HZnum;//Ŀ
	u16 TypefaceNum;//һַռֽڴС
	TypefaceNum=(sizey/8+((sizey%8)?1:0))*sizey;//ַռֽ
	HZnum=sizeof(tfont32)/sizeof(typFNT_GB32);	//ͳƺֿĿ
	Column_Address(x/4,x/4+sizey/4-1);
	Row_Address(y,y+sizey-1);
	for(k=0;k<HZnum;k++)
	{
		if ((tfont32[k].Index[0]==*(s))&&(tfont32[k].Index[1]==*(s+1)))
		{ 	
			for(i=0;i<TypefaceNum;i++)
			{
				for(j=0;j<4;j++)
				{
					if(tfont32[k].Msk[i]&(0x01<<(j*2+0)))
					{
						DATA=0xf0;
					}
					if(tfont32[k].Msk[i]&(0x01<<(j*2+1)))
					{
						DATA|=0x0f;
					}
					if(mode)
					{
						OLED_WR_Byte(~DATA);
					}else
					{
						OLED_WR_Byte(DATA);
					}
					DATA=0;
				}
			}
		}				  	
		continue;  //ҵӦֿ˳ֹظȡģӰ
	}
} 
//******************************************************************************
//    ˵OLEDʾַ 
//    ˺÷Χַ4ı  ַ߶ǿȵ2
//    ݣx,y   ʼ
//              chr   Ҫдַ
//              sizey ַ߶ 
//              mode  0:ʾ1ɫʾ
//    ֵ  
//******************************************************************************
void OLED_ShowChar(u8 x,u8 y,u8 chr,u8 sizey,u8 mode)
{
	u8 c,i,k,m,t=4,size2,data1,DATA=0;
	size2=(sizey/16+((sizey%16)?1:0))*sizey;
	c=chr-' ';//õƫƺֵ
	Column_Address(x/4,x/4+sizey/8-1);
	Row_Address(y,y+sizey-1);
	for(i=0;i<size2;i++)
	{
		if(sizey==16)
		{
			data1=ascii_1608[c][i];//8x16 ASCII
		}
		else if(sizey==24)
		{
			data1=ascii_2412[c][i];//12x24 ASCII
		}
		else if(sizey==32)
		{
			data1=ascii_3216[c][i];//16x32 ASCII
		}
//			else if(sizey==xx)               //Ҫµ壬ֻҪxx滻躺ָ߶
//			{                                //Ȼ½ascii_xxxx[][]ȡõģ
//				data=ascii_xxxx[c][i];
//			}
		if(sizey%16)
		{
			m=sizey/16+1;
			if(i%m) t=2;
			else t=4;
		}
		for(k=0;k<t;k++)
		{
			if(data1&(0x01<<(k*2+0)))
			{
				DATA=0xf0;
			}
			if(data1&(0x01<<(k*2+1)))
			{
				DATA|=0x0f;
			}
			if(mode)
			{
				OLED_WR_Byte(~DATA);
			}else
			{
				OLED_WR_Byte(DATA);
			}
			DATA=0;
		}
  }
}
//******************************************************************************
//    ˵OLEDʾַ
//    ݣx,y  ʼ
//              *dp   Ҫдַ
//              sizey ַ߶ 
//              mode  0:ʾ1ɫʾ
//    ֵ  
//******************************************************************************
void OLED_ShowString(u8 x,u8 y,u8 *dp,u8 sizey,u8 mode)
{
	while(*dp!='\0')
	{
	  OLED_ShowChar(x,y,*dp,sizey,mode);
		dp++;
		x+=sizey/2;
	}
}


//******************************************************************************
//    ˵m^n
//    ݣm: n:ָ
//    ֵ  result
//******************************************************************************
u32 oled_pow(u8 m,u8 n)
{
	u32 result=1;
	while(n--)result*=m;    
	return result;
}


//******************************************************************************
//    ˵OLEDʾ
//    ݣx,y :	 
//              num :Ҫʾı
//              len :ֵλ
//              sizey ַ߶ 
//              mode  0:ʾ1ɫʾ
//    ֵ  
//******************************************************************************
void OLED_ShowNum(u8 x,u8 y,u32 num,u8 len,u8 sizey,u8 mode)
{         	
	u8 t,temp;
	u8 enshow=0;
	for(t=0;t<len;t++)
	{
		temp=(num/oled_pow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				OLED_ShowChar(x+(sizey/2)*t,y,' ',sizey,mode);
				continue;
			}else enshow=1; 
		 	 
		}
	 	OLED_ShowChar(x+(sizey/2)*t,y,temp+'0',sizey,mode); 
	}
}

//******************************************************************************
//    ˵ʾҶͼƬ
//    ݣx,y :
//              length ͼƬ
//              width  ͼƬ
//              BMP[] :ҪʾͼƬ
//              mode  0:ʾ1ɫʾ
//    ֵ  
//******************************************************************************
void OLED_DrawBMP(u8 x,u8 y,u16 length,u8 width,const u8 BMP[],u8 mode)
{
	u16 i,num;
	length=(length/4+((length%4)?1:0))*4;
	num=length/2*width;
	x/=4;
	length/=4;
	Column_Address(x,x+length-1);
	Row_Address(y,y+width-1);
	for(i=0;i<num;i++)
	{
		if(mode)
		{
			OLED_WR_Byte(~BMP[i]);
		}else
		{
			OLED_WR_Byte(BMP[i]);
		}
	}
}

//******************************************************************************
//    ˵ʾɫͼƬ
//    ݣx,y :
//              length ͼƬ 
//              width  ͼƬ
//              BMP[] :ҪʾͼƬ
//              mode  0:ʾ1ɫʾ
//    ֵ  
//******************************************************************************
void OLED_DrawSingleBMP(u8 x,u8 y,u16 length,u8 width,const u8 BMP[],u8 mode)
{
	u8 k,DATA=0;
	u16 i,num;
	length=(length/8+((length%8)?1:0))*8;
	num=length*width/8;
	x/=4;
	length/=4;
	Column_Address(x,x+length-1);
	Row_Address(y,y+width-1);
	for(i=0;i<num;i++)
	{
		for(k=0;k<4;k++)
		{
			if(BMP[i]&(0x01<<(k*2+0)))
			{
				DATA=0xf0;
			}
			if(BMP[i]&(0x01<<(k*2+1)))
			{
				DATA|=0x0f;
			}
			if(mode)
			{
				OLED_WR_Byte(~DATA);
			}else
			{
				OLED_WR_Byte(DATA);
			}
			DATA=0;
		}
	}
}

//******************************************************************************
//    ˵OLEDʼ
//    ݣ
//    ֵ  
//******************************************************************************
void OLED_Init(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure;
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD|RCC_APB2Periph_GPIOE|RCC_APB2Periph_GPIOG,ENABLE);//ʹPORTA~E,PORTGʱ
 
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;//ٶ50MHz
  GPIO_Init(GPIOG, &GPIO_InitStructure);//ʼ
	GPIO_SetBits(GPIOG,GPIO_Pin_12);
	
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_15 ;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;//ٶ50MHz
  GPIO_Init(GPIOD, &GPIO_InitStructure);//ʼ
	GPIO_SetBits(GPIOD,GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_15);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;//ٶ50MHz
 	GPIO_Init(GPIOE, &GPIO_InitStructure);	  //ʼGPIOE10
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU; 	 //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;//ٶ50MHz
 	GPIO_Init(GPIOE, &GPIO_InitStructure);	  //ʼGPIOE8
	GPIO_SetBits(GPIOE,GPIO_Pin_10);
	
	OLED_RES_Clr();	
	delay_ms(10);	
	OLED_RES_Set();

	OLED_WR_REG(0xae); //Sleep In 
	
	OLED_WR_REG(0xfd);  /*Command Lock*/ 
	OLED_WR_Byte(0x12);
	
	OLED_WR_REG(0xb3);	//Set Display Clock Divide Ratio/Oscillator Frequency 
	OLED_WR_Byte(0x91);
	
	OLED_WR_REG(0xca);	//Set Multiplex Ratio 
	OLED_WR_Byte(0x3f);
	
	OLED_WR_REG(0xa2);	//Set Display Offset 
	OLED_WR_Byte(0x00);	//
	
	OLED_WR_REG(0xa1);	//Set Display Start Line 
	OLED_WR_Byte(0x00);	//
	
	OLED_WR_REG(0xa0);	//Set Re-Map $ Dual COM Line Mode
	if(USE_HORIZONTAL)
	{
	  OLED_WR_Byte(0x14);
	}
	else
	{
	  OLED_WR_Byte(0x06);
	}
	
	OLED_WR_REG(0xB5);	//Set GPIO 
	OLED_WR_Byte(0x00);
		
	OLED_WR_REG(0xab);	//Function Selection
	OLED_WR_Byte(0x01);	//
	
	OLED_WR_REG(0xb4);	//Enable External VSL 
	OLED_WR_Byte(0xa0);	//
	OLED_WR_Byte(0xf8);	//
	
	OLED_WR_REG(0xc1);	//Set Contrast Current
	OLED_WR_Byte(0xef);	
	
	OLED_WR_REG(0xc7);	//Master Contrast Current Control
	OLED_WR_Byte(0xff);	//

	OLED_WR_REG(0xB8); //  	// Set Gray Scale Table 
	OLED_WR_Byte(0x0C); //
	OLED_WR_Byte(0x18); //
	OLED_WR_Byte(0x24); //
	OLED_WR_Byte(0x30); //
	OLED_WR_Byte(0x3C); //
	OLED_WR_Byte(0x48); //
	OLED_WR_Byte(0x54); //
	OLED_WR_Byte(0x60); //
	OLED_WR_Byte(0x6C); //
	OLED_WR_Byte(0x78); //
	OLED_WR_Byte(0x84); //
	OLED_WR_Byte(0x90); //
	OLED_WR_Byte(0x9C); //
	OLED_WR_Byte(0xA8); //
	OLED_WR_Byte(0xB4); //
 	OLED_WR_REG(0x00); 	// Enable Gray Scale Table
	
	OLED_WR_REG(0xb1);	//Set Phase Length
	OLED_WR_Byte(0xe2);	
	
	OLED_WR_REG(0xd1);	//Enhance Driving Scheme Capability 
	OLED_WR_Byte(0xa2);	
	OLED_WR_Byte(0x20);	

	OLED_WR_REG(0xbb);	//Set Pre-Charge Voltage 
	OLED_WR_Byte(0x1f);	

	OLED_WR_REG(0xb6);	//Set Second Pre-Charge Period 
	OLED_WR_Byte(0x08);	

	OLED_WR_REG(0xbe);	//Set VCOMH Deselect Level 
	OLED_WR_Byte(0x07);		

	OLED_WR_REG(0xa6);	//Set Display Mode
	
	OLED_WR_REG(0xA9); //Disable Partial Display
	OLED_Fill(0,0,256,64,0x00);   //Clear Screen

	OLED_WR_REG(0xaf);	//Sleep Out
}



